// @flow
export function assign<T: {}>(...objects: T): T {
  return Object.assign(({}: any), ...objects);
}

export function isEqual(item1: any, item2: any): boolean {
  return JSON.stringify(item1) === JSON.stringify(item2);
}

export function isArray(item: any): boolean {
  return Array.isArray(item);
}

export function isObject(item: any) {
  return item !== null && item && typeof item === 'object' && !Array.isArray(item);
}

export function isFunction(item: any) {
  return typeof item === 'function';
}

export function isString(item: any) {
  return item && typeof item === 'string';
}

export function forEach(element: any, fn: Function): number {
  return Array.prototype.forEach.call(element, fn);
}
