/* eslint-disable no-cond-assign */
/* eslint-disable no-bitwise */
const CHARCODE_0 = '0'.charCodeAt(0);
const MAPPING_EVEN = [0, 2, 4, 6, 8, 1, 3, 5, 7, 9];

export function getLuhnRemainder(value) {
  let { length } = value;
  let accumulator = 0;
  let bit = 0;

  while (length-- > 0) {
    accumulator += (bit ^= 1)
      ? value.charCodeAt(length) - CHARCODE_0
      : MAPPING_EVEN[value.charCodeAt(length) - CHARCODE_0];
  }

  return accumulator % 10;
}

export function isLuhnValid(value) {
  return getLuhnRemainder(value) === 0;
}

export function generateLuhn(value) {
  return value + ((10 - getLuhnRemainder(`${value}0`)) % 10).toString();
}
