// @flow
import { forEach } from './index';

const svgContainer: Element = document.createElement('div');

const setSvg = (source: string): any => {
  svgContainer.innerHTML = source;

  return svgContainer.firstChild;
};

export const setSvgFill = (el: Element) => {
  forEach(el.childNodes, (node) => {
    const fill = node.getAttribute('fill');
    if (fill && fill !== 'none') {
      node.removeAttribute('fill');
    }
  });
};

export const createSvgLegacy = (el: Element, source: string) => {
  const svg: Element = setSvg(source);

  while (svg.firstChild) {
    el.appendChild(svg.firstChild);
  }
};
